#ifndef ALTERNATING_ADAPTIVE_MEANS2GMM_THEN_LLOYDSFORGMM_ID_H
#define ALTERNATING_ADAPTIVE_MEANS2GMM_THEN_LLOYDSFORGMM_ID_H

#include "../../../base/gmmutil.h"
#include "../../../base/gmmdesc.h"
#include "../initdescriptor.h"

/**
 * @brief Descriptor for Initialization
 */
class AlternatingAdaptiveMeans2GMMThenLloydsForGMMID : public InitDescriptor
{
public:
	AlternatingAdaptiveMeans2GMMThenLloydsForGMMID(fp_type factor, bool spherical, unsigned int substeps, bool sphericalLloyds, uint32_t seed = 1);

	virtual ~AlternatingAdaptiveMeans2GMMThenLloydsForGMMID()
	{
	}
	
	GMMDesc compute(commonutil::DataSet const&, unsigned int);

private:
	uint32_t seed;
	unsigned int substeps;
	fp_type factor;
	bool spherical;
	bool sphericalLloyds;
};

#endif
